<template>
  <v-card :loading="isLoading">
    <v-card-title>Créer un item !</v-card-title>
    <v-card-text>
      <v-form
        @submit.prevent="()=>createItem(itemToCreate)"
      >
        <v-combobox
          label="Item type"
          v-model="itemType"
          :items="['Simple', 'Group', 'Counter']"
          variant="filled"
        ></v-combobox>
        <simple-item-form
          virgin
          v-if="itemType === 'Simple'"
          v-model="itemToCreate"
        ></simple-item-form>
        <group-item-form
          virgin
          v-if="itemType === 'Group'"
          v-model="itemToCreate"
        ></group-item-form>
        <counter-item-form
          virgin
          v-if="itemType === 'Counter'"
          v-model="itemToCreate"
        ></counter-item-form>
        <v-card-actions>
          <v-btn type="submit" color="success" variant="flat">Create</v-btn>
          <v-btn color="error" variant="flat" @click.stop="$emit('CANCEL')">Cancel</v-btn>
        </v-card-actions>
      </v-form>
    </v-card-text>
  </v-card>
</template>

<script>
import SimpleItemForm from '@/components/item/simple/simple-item-form.vue'
import GroupItemForm from '@/components/item/group/group-item-form.vue'
import CounterItemForm from '@/components/item/counter/counter-item-form.vue'
import { useCollectionsStore } from '@/stores/itemCollections.js'

export default {
  name: "ck-item-creation",
  components: { CounterItemForm, GroupItemForm, SimpleItemForm },
  data() {
    return {
      itemToCreate: {},
      active: false,
      itemType: "Simple",
      isLoading: false
    }
  },
  props: {
    collectionId: {
      type: String,
      required: true
    },
    order: {
      type: Number,
      required: true
    },
  },
  methods: {
    async createItem(itemToCreate) {
      this.isLoading = true

      switch (this.itemType) {
        case 'Simple':
          await useCollectionsStore()
            .putSimpleItem(this.collectionId, itemToCreate, this.order)
            .then(() => this.tearDown());
          break;
        case 'Group':
          await useCollectionsStore()
            .putGroupItem(this.collectionId, itemToCreate, this.order)
            .then(() => this.tearDown());
          break;
        case 'Counter':
          await useCollectionsStore()
            .putCounterItem(this.collectionId, itemToCreate, this.order)
            .then(() => this.tearDown());
          break;
      }
      this.tearDown()
    },
    tearDown() {
      this.isLoading = false
      this.$emit('created')
    }
  }
}
</script>

<style scoped>
</style>